=== debian/changelog ===
r-base (1.8.0.cvs.20031114-1) unstable; urgency=low

  * Upgraded to the initial 1.8.1 beta release of 2003-11-14

 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 14 Nov 2003 19:13:43 -0600

r-base (1.8.0.cvs.20031107-1) unstable; urgency=low

  * Upgraded to the initial 1.8.1 alpha release of 2003-11-07
  * debian/rules: Configure with R_PRINTCMD=/usr/bin/lpr (Closes: #219419)

 -- Dirk Eddelbuettel <edd@debian.org>  Fri,  7 Nov 2003 19:56:48 -0600

r-base (1.8.0.cvs.20031101-1) unstable; urgency=low

  * Upgraded to 1.8.0 patched aka pre-1.8.1 as of 2003-11-01
  * Also upgraded R-recommended via rsync
  * debian/rules: make docs has to be called when binary-arch is built 

 -- Dirk Eddelbuettel <edd@debian.org>  Sat,  1 Nov 2003 18:58:09 -0600

r-base (1.8.0.cvs.20031024-1) unstable; urgency=low

  * Upgraded to 1.8.0 patched as of 2003-10-24
  * Also upgraded R-recommended via rsync
  * To avoid possible upgrade conflicts with pre-releases of 1.8.1, we 
    use previously used ".cvs.YYYYMMDD" naming convention for the package
  * debian/rules: 'make {docs,help,html}' are now called in binary-indep
    which was not possible with earlier versions of R; however as make
    recommended implies make doc, we manually descend into its top dir.

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 23 Oct 2003 15:21:35 -0500

r-base (1.8.0-2) unstable; urgency=low

  * With a big thanks to Camm Maguire for investigating this problem,
    we are reverting back to the previously used setup of defaulting to 
    Blas while automagically switching to Atlas where installed:
    - debian/rules: Patch R.sh.in to disable use of R_LD_LIBRARY_PATH (beyond
      the required $R_HOME/nbin) which conflicts with Debian's transparent 
      switch of Atlas for Blas (as /usr/lib/libblas would be found instead)
    - debian/rules: Configure again with --with-blas=blas
    - debian/control: Hence remove Depends: on atlas2-base-dev | atlas2-dev
    - debian/shlibs.local: Remove, no longer needed
    - debian/rules: No longer need to postprocess Depends
    - debian/rules: Other small cleanups

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 16 Oct 2003 20:13:32 -0500

r-base (1.8.0-1) unstable; urgency=low

  * Upgraded to version 1.8.0 released today

 -- Dirk Eddelbuettel <edd@debian.org>  Wed,  8 Oct 2003 10:10:41 -0500

r-base (1.7.1.cvs.20031004-1) unstable; urgency=low

  * Upgraded to release candidate 1.8.0beta_2003-10-04 of R 1.8.0
  * debian/control: Change Depends: to atlas2-base-dev | atlas2-dev 

 -- Dirk Eddelbuettel <edd@debian.org>  Sat,  4 Oct 2003 07:39:13 -0500

r-base (1.7.1.cvs.20030927-1) unstable; urgency=low

  * Upgraded to release candidate 1.8.0beta_2003-09-27 of R 1.8.0
  * debian/control: Add Depends: on atlas2-dev for r-base-dev

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 27 Sep 2003 15:58:45 -0500

r-base (1.7.1.cvs.20030920-1) unstable; urgency=low

  * Upgraded to release candidate 1.8.0alpha_2003-09-20 of R 1.8.0
  * debian/{r-base-core,r-gnome}.menu: Small beautifications

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 20 Sep 2003 08:02:54 -0500

r-base (1.7.1.cvs.20030913-1) unstable; urgency=low

  * Upgraded to release candidate 1.8.0alpha_2003-09-13 of R 1.8.0

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 13 Sep 2003 09:59:45 -0500

r-base (1.7.1.cvs.20030906-1) unstable; urgency=low

  * Upgraded to release candidate 2003-09-06 of R 1.8.0

 -- Dirk Eddelbuettel <edd@debian.org>  Sat,  6 Sep 2003 15:21:02 -0500

r-base (1.7.1.cvs.20030830-1) unstable; urgency=low

  * Upgraded to release candidate 2003-08-30 of R 1.8.0

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 30 Aug 2003 09:56:10 -0500

r-base (1.7.1.cvs.20030822-1) unstable; urgency=low

  * Upgraded to release candidate 2003-08-22 of R 1.8.0
  * debian/control: Standards-Version increased to 3.6.1.0

 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 22 Aug 2003 20:25:52 -0500

r-base (1.7.1.cvs.20030814-1) unstable; urgency=low

  * Upgraded to release candidate 2003-08-14 of R 1.7.2 (or 1.8.0)

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 14 Aug 2003 20:39:05 -0500

r-base (1.7.1.cvs.20030808-1) unstable; urgency=low

  * Upgraded to release candidate 2003-08-08 of R 1.7.2 (or 1.8.0)
  * Upstream release candidate sources do not contain the source for the
    r-recommended package so tools/rsync-recommended was used to obtain
    these and a new, Debian-only, orig.tar.gz of both was created
  * debian/control: r-base-dev now has a versioned Depends on r-base-core
    which requires equal version numbers between the two (Closes: #199295)
  * debian/control: Upgraded Standards-Version to 3.6.0

 -- Dirk Eddelbuettel <edd@debian.org>  Fri,  8 Aug 2003 20:08:49 -0500

r-base (1.7.1-1) unstable; urgency=low

  * New upstream version 1.7.1 released today

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 16 Jun 2003 19:36:45 -0500

r-base (1.7.0.cvs.20030607-1) unstable; urgency=low

  * Upgraded to initial release candidate (dated 2003-06-07) of R 1.7.1
  * debian/{control,rules}: Switch back to default compiler version as 3.3 
    is in unstable and testing; m68k still needs f2c for Fortan code

 -- Dirk Eddelbuettel <edd@debian.org>  Sat,  7 Jun 2003 12:23:59 -0500

r-base (1.7.0.cvs.20030602-1) unstable; urgency=low

  * Upgraded to initial release candidate (dated 2003-06-02) of R 1.7.1
  * debian/{rules,control}: Try f2c on m68k as a last resort

 -- Dirk Eddelbuettel <edd@debian.org>  Mon,  2 Jun 2003 21:31:42 -0500

r-base (1.7.0.cvs.20030526-1) unstable; urgency=low

  * Upgraded to release candidate 2003-05-26 of R 1.7.1
  * Manually rsync'ed r-recommendeds sources as R-patched pre-release do
    not comprise r-recommended, also manually re-built upstream tarball
  * debian/control: Require gcc/g++/g77-3.2 as version 3.3 is in unstable
    gcc 3.2 works fine everywhere with the exception of m68k (Closes: #194175)
  * debian/shlibs.local: Have libatlas imply either the actual atlas2-base 

